image: docker
variables:
    CONTAINER_NAME: 'traffic'
stages:
  - build
  - test
  - Static Analysis
  - deploy
before_script:
  - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN registry.gitlab.com
build:
  stage: build
  tags:
    - docker-in-docker-pure-builder
  script:
    - docker build -t registry.gitlab.com/nahed.abid/my_simple_pipeline .
    
unittest:
  stage: test
  before_script:
    - docker container stop ${CONTAINER_NAME}
    - docker container rm ${CONTAINER_NAME}
  tags:
    - docker-in-docker-builder
  script:
    - docker run -d --name ${CONTAINER_NAME} registry.gitlab.com/nahed.abid/my_simple_pipeline
    - docker exec -i ${CONTAINER_NAME} python3 -m unittest object_detection/generate_tfrecord_test.py
    #- docker-compose exec -T python -m unittest -v object_detection/generate_tfrecord_test
pytest:
  stage: test
  before_script:
    - docker container stop ${CONTAINER_NAME}
    - docker container rm ${CONTAINER_NAME}
  tags:
    - docker-in-docker-builder
  script:
    - docker run -d --name ${CONTAINER_NAME} registry.gitlab.com/nahed.abid/my_simple_pipeline
    - docker exec -i ${CONTAINER_NAME} pytest object_detection/test_generate_tfrecord.py -v
    
autopep8:
  stage: Static Analysis
  before_script:
    - docker container stop ${CONTAINER_NAME}
    - docker container rm ${CONTAINER_NAME}
  tags:
    - docker-in-docker-builder
  script:
  - docker run -d --name ${CONTAINER_NAME} registry.gitlab.com/nahed.abid/my_simple_pipeline
  #- docker exec -i ${CONTAINER_NAME} pip3 install -r object_detection/requirments.txt
  - docker exec -i ${CONTAINER_NAME} autopep8 --in-place --aggressive --aggressive object_detection/test_generate_tfrecord.py 
  

mypy:
  stage: Static Analysis
  before_script:
    - docker container stop ${CONTAINER_NAME}
    - docker container rm ${CONTAINER_NAME}
 
  tags:
    - docker-in-docker-builder
  script:
  - docker run -d --name ${CONTAINER_NAME} registry.gitlab.com/nahed.abid/my_simple_pipeline
 # - docker exec -i ${CONTAINER_NAME} pip3 install -r object_detection/requirments.txt
  - docker exec -i ${CONTAINER_NAME} mypy object_detection/test_generate_tfrecord.py  --ignore-missing-imports
  - docker exec -i ${CONTAINER_NAME} mypy object_detection/generate_tfrecord.py  --ignore-missing-imports

  
deploy:
  stage: deploy
  variables:
    IMAGE: registry.gitlab.com/nahed.abid/my_simple_pipeline
    RELEASE_IMAGE: registry.gitlab.com/nahed.abid/my_simple_pipeline:latest
  tags:
    - docker-in-docker-builder
  script:
    # tag the final image (the previous test image is built upon the test image file)
    - docker tag $IMAGE $IMAGE
    - docker push $IMAGE
#    # tag the full image as lastest and push it
    - docker tag $IMAGE $RELEASE_IMAGE
    - docker push $RELEASE_IMAGE
#    # deploy the images
    - docker pull $RELEASE_IMAGE
#    # stop the running container
    - docker rm -f ${CONTAINER_NAME}
#    # run on localhost
    - docker run -d --add-host 'localhost localhost.localdomain localtest:127.0.0.1' --name ${CONTAINER_NAME} -p 8888:8888 $RELEASE_IMAGE